


/* Version and code information

*/

String Version = "1.0.6 L";
String VerDate = "Nov 15, 2019";

/*
 * Ver  1.0.7 Nov 15  ,2019 Work Error temperature.
 * Ver  1.0.6 Nov 14  ,2019 Added cyclying through each temperature zone one per second.
 *                          Changed how temp sensor errors are sent.
 * Ver  1.0.5 Nov  12, 2019 Added ligt level sensor LX
 *                          Added watchdog reset
 *                          raise temperatur erros count to 15
 * Ver  1.0.4 Nov  11, 2019 Changed send back to original,  lowered baud rate to 4800
 *                          Flush serail buffer
 * Ver 1.0.3  Nov 10, 2019  Change pin 38 to pin 36 - rear LO FAN
 *                          MY BAD - didn't have pin assigned as output........  left it on 36
 *                          Shorten serial packet, changed to 19200, send packets every other time
 * Ver 1.0.2  Nov 6, 2019   Add WR - return the watchdog back to the Raspberry.
 * Ver 1.0.0  Nov 2, 2019   Release
 * Ver 1.0.1  Nov 4, 2019   All ALM8 to com alarm.  Move rx byte from every scan to 1/2 second
 *                          AmpsCheck
 * 
 */

#include <OneWire.h>
#include <DallasTemperature.h>

#include "EmonLib.h"

#include <Wire.h>
#include <BH1750.h>

BH1750 lightMeter;

EnergyMonitor emon1;
EnergyMonitor emon2;
EnergyMonitor emon3;

// Data wire is plugged into pin 2 on the Arduino
#define ONE_WIRE_BUS 24
/********************************************************************/
// Setup a oneWire instance to communicate with any OneWire devices
// (not just Maxim/Dallas temperature ICs)
OneWire oneWire(ONE_WIRE_BUS);
/********************************************************************/
// Pass our oneWire reference to Dallas Temperature.
// DS18B20 sensor
DallasTemperature sensors(&oneWire);

#define ONE_WIRE_BUS 24


#define LCD_RESET A4 // Can alternately just connect to Arduino's reset pin
#define Pin_FR_Furnace  52
#define Pin_FR_Compressor  50
#define Pin_FR_FanHI  48
#define Pin_FR_FanLO  46
#define Pin_RR_Furnace  44
#define Pin_RR_Compressor  42
#define Pin_RR_FanHI  40
#define Pin_RR_FanLO  36
// may have problem with 38

#define Pin_Volts_Shore 34
#define Pin_Volts_Gen 32
#define Pin_Volts_GenAC 30
#define Pin_Amps_Shore 8
#define Pin_Amps_Gen 9
#define Pin_Amps_GenAC 10

#define Pin_AL_8  53
#define Pin_AL_7  51
#define Pin_AL_6  49
#define Pin_AL_5  47
#define Pin_AL_4  45
#define Pin_AL_3  43
#define Pin_AL_2  41
#define Pin_AL_1  39

void(* resetFunc) (void) = 0;

void setup(void) {
	Serial.begin(9600);
  Serial1.begin(19200);
    Wire.begin();
  // On esp8266 you can select SCL and SDA pins using Wire.begin(D4, D3);

  lightMeter.begin();
  
  Serial.println();
	Serial.print("Version > ");
  Serial.println(Version);
  Serial.print("Date > ");
  Serial.println(VerDate);

	// 8 Relay output
	pinMode(Pin_FR_Furnace, OUTPUT);
	pinMode(Pin_FR_Compressor, OUTPUT);
	pinMode(Pin_FR_FanHI, OUTPUT);
	pinMode(Pin_FR_FanLO, OUTPUT);
	pinMode(Pin_RR_Furnace, OUTPUT);
	pinMode(Pin_RR_Compressor, OUTPUT);
	pinMode(Pin_RR_FanHI, OUTPUT);
  pinMode(Pin_RR_FanLO, OUTPUT);

  pinMode(Pin_Volts_Shore, INPUT);
  pinMode(Pin_Volts_Gen, INPUT);
  pinMode(Pin_Volts_GenAC, INPUT);

	digitalWrite(Pin_FR_Furnace, HIGH);
	digitalWrite(Pin_FR_Compressor, HIGH);
	digitalWrite(Pin_FR_FanHI, HIGH);
	digitalWrite(Pin_FR_FanLO, HIGH);
	digitalWrite(Pin_RR_Furnace, HIGH);
	digitalWrite(Pin_RR_Compressor, HIGH);
	digitalWrite(Pin_RR_FanHI, HIGH);
	digitalWrite(Pin_RR_FanLO, HIGH);


  // 8 Relay output
  pinMode(Pin_AL_8, OUTPUT);
  pinMode(Pin_AL_7, OUTPUT);
  pinMode(Pin_AL_6, OUTPUT);
  pinMode(Pin_AL_5, OUTPUT);
  pinMode(Pin_AL_4, OUTPUT);
  pinMode(Pin_AL_3, OUTPUT);
  pinMode(Pin_AL_2, OUTPUT);
  pinMode(Pin_AL_1, OUTPUT);

  digitalWrite(Pin_AL_8, HIGH);
  digitalWrite(Pin_AL_7, HIGH);
  digitalWrite(Pin_AL_6, HIGH);
  digitalWrite(Pin_AL_5, HIGH);
  digitalWrite(Pin_AL_4, HIGH);
  digitalWrite(Pin_AL_3, HIGH);
  digitalWrite(Pin_AL_2, HIGH);
  digitalWrite(Pin_AL_1, HIGH);


	//Declaring LED pin as output

	emon1.current(Pin_Amps_Shore, 23);   // Shore
	emon2.current(Pin_Amps_Gen, 28);  // Gennerator
	emon3.current(Pin_Amps_GenAC, 17);  // Generator AC
 // Calibrated using ammeter and various loads

}
int AmpsCheck = 0;

int Temp_1;
int Temp_2;
int Temp_3;
int TempIn_1;
int TempIn_2;
int TempIn_3;
int TempError1 =  0;
int TempError2 =  0;
int TempError3 =  0;
int TempCheck = 0;



boolean FirstPass = false;

unsigned long OldMSCount;
unsigned long OldHalfMSCount;
unsigned long MSCount;

boolean SecTick;

boolean ShorePower;
boolean GennyPower;
boolean GennyACPower;

int AmpsShorePower;
int AmpsGennyPower;
int AmpsGennyACPower;

boolean FR_Furnace;
boolean FR_Compressor;
boolean FR_FanHI;
boolean FR_FanLO;
boolean RR_Furnace;
boolean RR_Compressor;
boolean RR_FanHI;
boolean RR_FanLO;

boolean AL_8; // Used for Comm Alarm
boolean AL_7;
boolean AL_6;
boolean AL_5;
boolean AL_4;
boolean AL_3;
boolean AL_2;
boolean AL_1;

int TxWatchDog = 0;  //  This is the WD that we transmit 
int WatchDog = 0;
int OldWatchDog = 0;
int WDTest = 10;
boolean CommError = true;
boolean NotRXMe = true;  // The Raspberry is not recieving me.
boolean AlarmClock = false;
String TempString = "";
String RxTempString = "";
int TempInt;
String TempData;
int DataInt;
String inData;
boolean ShowSerial = false;
boolean TxDataSelect = false;
byte incomingByte;
String _SerialRead = "";
int lux;

void loop() 
{
	/* First Pass,  ste up screens and parameters */
	if (FirstPass == false) {
		FirstPass = true;

		/*  TEST  */
		// VoltageShorePower = true;
		// VoltageGennyPower = false;
		// VoltageGennyACPower = false;

		// AmpsGennyPower = 0;
		// AmpsGennyACPower = 0;
		// AmpsShorePower = 32;

    //    ShowSerial = true;


		FR_Furnace = false;
		FR_Compressor = false;
		FR_FanHI = false;
		FR_FanLO = false;
		RR_Furnace = false;
		RR_Compressor = false;
		RR_FanHI = false;
		RR_FanLO = false;

    AL_8 = false;
    AL_7 = false;
    AL_6 = false;
    AL_5 = false;
    AL_4 = false;
    AL_3 = false;
    AL_2 = false;
    AL_1 = false;

	}
 AmpsCheck = AmpsCheck + 1;
 if (AmpsCheck > 2) { 
  //ReadAmps();
  AmpsCheck = 0; 
  }
    ReadAmps();
 

/* This runs a 1 second tick flag  */
	MSCount = millis();
	if (((MSCount - OldMSCount) >= 1000) || (MSCount < OldMSCount)) {
		// SecTick = true;
		OldMSCount = MSCount;

		// Watchdog test for recieved communications
    // Serial.println(WatchDog);
		if (WatchDog != OldWatchDog) {
			OldWatchDog = WatchDog;
			WDTest = 0;
			CommError = false;
       // Serial.println(WatchDog);
			}
		
		WDTest = WDTest + 1;
		if (WDTest > 10) {
			// WDTest = 10;
			CommError = true; 
      Serial.println("RX COMM ERROR");   
      // If the serial port isn't recieving for more than 60 seconds,  reset
      if (WDTest > 60)    {
        resetFunc();
      }
		}	
		
		// Serial.println(MSCount);

  lux = lightMeter.readLightLevel();
  
   ReadVolts();
   ReadTemps();
   OutputRelays();
        //TxWatchDog = rand()% 1000 + 1;
   WriteSerial();
    // ReadSerialByte();
   	// Serial.println(lux); 
	}  //  ONE SECOND 


//  This is 1/2 second
	if (((MSCount - OldHalfMSCount) >= 500) || (MSCount < OldHalfMSCount)) {
		OldHalfMSCount = MSCount;
    // OutputRelays();
     //TxWatchDog = rand()% 1000 + 1;
    // ReadAmps();
     // WriteSerial();
     // Serial.println(TxWatchDog);
     ReadSerialByte();
	}  // end 1/2 second

   // ReadSerialByte();
 

}  //  void loop() 

void WriteSerial()
{

  TxWatchDog = rand()% 1000 + 1;
  
  TempString = "Version[" + Version+"]";
   Serial1.println(TempString);
  TempString = "Date[" + VerDate+"]";
   Serial1.println(TempString);
  TempString = "WD[" + String(TxWatchDog)+"]";
   Serial1.println(TempString); 
  TempString = "WR[" + String(WatchDog)+"]";
   Serial1.println(TempString); 
  TempString = "T1[" + String(Temp_1)+"]";
   Serial1.println(TempString);  
  TempString = "T2[" + String(Temp_2)+"]";
   Serial1.println(TempString); 
  TempString = "T3[" + String(Temp_3)+"]";
   Serial1.println(TempString);  
  TempString = "LX[" + String(lux)+"]";
   Serial1.println(TempString);  
  TempString = "SA[" + String(AmpsShorePower)+"]";
   Serial1.println(TempString); 
  TempString = "SV[" + String(ShorePower)+"]";
   Serial1.println(TempString);
  TempString = "GA[" + String(AmpsGennyPower)+"]";
   Serial1.println(TempString); 
  TempString = "GV[" + String(GennyPower)+"]";
   Serial1.println(TempString);  
  TempString = "RA[" + String(AmpsGennyACPower)+"]";
   Serial1.println(TempString); 
  TempString = "RV[" + String(GennyACPower)+"]";
   Serial1.println(TempString);  

 //  }

}

void serial_flush_buffer()
{
  while (Serial.read() >= 0)
   ; // do nothing
}

void ReadSerialByte() {
  while (Serial1.available())        //Only run when there is data available
  {
    RxTempString += char(Serial1.read()); //Here every received char will be
                                        //added to _SerialRead
    //delay(5);
    if (RxTempString.indexOf("\r") > 0)   //Checks for new line in string
    {
      // Serial.println("REC >" + RxTempString + "<"); 
     TempInt = RxTempString.length();
     TempString = RxTempString.substring(0,3);
     TempData = RxTempString.substring(3,(TempInt - 2));
     DataInt = TempData.toInt();
     if (ShowSerial) { 
      Serial.print(TempInt);
      Serial.print("  >");
      Serial.print(TempString);
      Serial.print("<  ");
      Serial.print(TempData);
      Serial.print("  ");
      Serial.print(DataInt);
      Serial.print("  ");
      Serial.println("REC > " + RxTempString); 
      }
         // Serial.println(RxTempString);
      RxTempString = "";                 // clear the string

     if (TempString == "RL[") 
     {
           FR_Furnace = false;
           FR_Compressor = false;
           FR_FanHI = false;
           FR_FanLO = false;
           RR_Furnace = false;
           RR_Compressor = false;
           RR_FanHI = false;
           RR_FanLO = false;
           
        // Bit Assignment 8 bits  > (msb)  FF, FC, FH, FL, RF, RC, RH, RL  (lsb) 
        
           if ((DataInt & B10000000) > 0) { FR_Furnace = true ; }
           if ((DataInt & B01000000) > 0) { FR_Compressor = true ; }
           if ((DataInt & B00100000) > 0) { FR_FanHI = true ; }
           if ((DataInt & B00010000) > 0) { FR_FanLO = true ; }
           if ((DataInt & B00001000) > 0) { RR_Furnace = true ; }
           if ((DataInt & B00000100) > 0) { RR_Compressor = true ; }
           if ((DataInt & B00000010) > 0) { RR_FanHI = true ; }
           if ((DataInt & B00000001) > 0) { RR_FanLO = true ; }
     }  //   if (TempString == "RL[") 
      
      if (TempString == "AL[")
      { 
           AL_8 = false;
           AL_7 = false;
           AL_6 = false;
           AL_5 = false;
           AL_4 = false;
           AL_3 = false;
           AL_2 = false;
           AL_1 = false;
           
        // Bit Assignment ALarms (8 bits  > (msb)  FF, FC, FH, FL, RF, RC, RH, RL  (lsb) )
        
           if ((DataInt & B10000000) > 0) { AL_8 = true ; }
           if ((DataInt & B01000000) > 0) { AL_7 = true ; }
           if ((DataInt & B00100000) > 0) { AL_6 = true ; }
           if ((DataInt & B00010000) > 0) { AL_5 = true ; }
           if ((DataInt & B00001000) > 0) { AL_4 = true ; }
           if ((DataInt & B00000100) > 0) { AL_3 = true ; }
           if ((DataInt & B00000010) > 0) { AL_2 = true ; }
           if ((DataInt & B00000001) > 0) { AL_1 = true ; }
      }  //  if (TempString == "AL[")

      if (TempString == "WD[")
      { 
          WatchDog = DataInt;  
          // Serial.println(WatchDog);      
      }  //  if (TempString == "WD[")

      if (TempString == "CO[")
      { 
          NotRXMe = DataInt;        
      }  //  if (TempString == "WD[")

    //TempInt = TempString.length();
    //Serial.print(TempInt);
       //Serial.println(" >"+TempString + "+++++++++");
    }  //  if (RxTempString.indexOf("\r") > 0)
    // Serial.println(" >"+TempString + "+++++++++");
  }  //  while (Serial1.available() > 0) 
  //Serial.println(" >"+TempString + "+++++++++");
}



void OutputRelays()
{
	   if (CommError){  //  If comm error then shut everything off.

           FR_Furnace = false;
           FR_Compressor = false;
           FR_FanHI = false;
           FR_FanLO = false;
           RR_Furnace = false;
           RR_Compressor = false;
           RR_FanHI = false;
           RR_FanLO = false;
	
	   } 

		digitalWrite(Pin_FR_Furnace, (FR_Furnace ^ 1)); // Exclusive OR
		digitalWrite(Pin_FR_Compressor, (FR_Compressor ^ 1)); // Exclusive OR HIGH)
		digitalWrite(Pin_FR_FanHI, (FR_FanHI ^ 1)); // Exclusive OR HIGH)
		digitalWrite(Pin_FR_FanLO, (FR_FanLO ^ 1)); // Exclusive OR HIGH)
		digitalWrite(Pin_RR_Furnace, (RR_Furnace ^ 1)); // Exclusive OR HIGH)
		digitalWrite(Pin_RR_Compressor, (RR_Compressor ^ 1)); // Exclusive OR HIGH)
		digitalWrite(Pin_RR_FanHI, (RR_FanHI ^ 1)); // Exclusive OR HIGH)
		digitalWrite(Pin_RR_FanLO, (RR_FanLO ^ 1)); // Exclusive OR HIGH)
   
    digitalWrite(Pin_AL_8,  (CommError ^ 1));  // Exclusive OR HIGH  COMM ERROR

    TempString = "";
    if (FR_Furnace) {TempString = TempString + "1";  }  else  {TempString = TempString + "0"; }
    if (FR_Compressor) {TempString = TempString + "1";  }  else  {TempString = TempString + "0"; }
    if (FR_FanHI) {TempString = TempString + "1";  }  else  {TempString = TempString + "0"; }
    if (FR_FanLO) {TempString = TempString + "1";  }  else  {TempString = TempString + "0"; }
    if (RR_Furnace) {TempString = TempString + "1";  }  else  {TempString = TempString + "0"; }
    if (RR_Compressor) {TempString = TempString + "1";  }  else  {TempString = TempString + "0"; }
    if (RR_FanHI) {TempString = TempString + "1";  }  else  {TempString = TempString + "0"; }
    if (RR_FanLO) {TempString = TempString + "1";  }  else  {TempString = TempString + "0"; }

  // Serial.println("COMMAND > "+TempString);

  
}  //  void OutputRelays()

void ReadAmps()
{
  /*
  AmpsShorePower = emon1.calcIrms(50); 
        AmpsGennyPower = emon2.calcIrms(50); 
              AmpsGennyACPower = emon3.calcIrms(50); 
              */
        
	if (AmpsCheck == 0)  { 
	    AmpsShorePower = emon1.calcIrms(500); 
	    if (AmpsShorePower > 99) { AmpsShorePower = 99;  }
      if (AmpsShorePower < 0) { AmpsShorePower = 0;  }
	  }
   
	if (AmpsCheck == 1)  { 
	    AmpsGennyPower = emon2.calcIrms(500); 
	    if (AmpsGennyPower > 99) { AmpsGennyPower = 99;  }
      if (AmpsGennyPower < 0) { AmpsGennyPower = 0;  } 
	  }
 
	if (AmpsCheck == 2)  {  
	    AmpsGennyACPower = emon3.calcIrms(500); 
	    if (AmpsGennyACPower > 99) { AmpsGennyACPower = 99; }
      if (AmpsGennyACPower < 0) { AmpsGennyACPower = 0; }
	  }


}  //  void ReadAmps ()

void ReadVolts ()
{


if (digitalRead(Pin_Volts_Shore)) {
  ShorePower = false;
} else {
   ShorePower = true;
}


if (digitalRead(Pin_Volts_Gen)) {
  GennyPower = false;
} else {
   GennyPower = true;
}

if (digitalRead(Pin_Volts_GenAC)) {
  GennyACPower = false;
} else {
   GennyACPower = true;
}
   // ShorePower = digitalRead(Pin_Volts_Shore);
   // GennyPower = digitalRead(Pin_Volts_Gen);
   // GennyACPower = digitalRead(Pin_Volts_GenAC);
	// ShorePower;
	// GennyPower;
	// GennyACPower;

}  //  void ReadVolts ()

void ReadTemps()
{  // we read temperatures once a second
  // If the sensor reports between -50 and 150,  we use it.
  // If comes back less than -50 we set it at -60
  // If it comes back greater than 150, we set it at 160

if (TempCheck == 0) {
    TempIn_1 = sensors.getTempFByIndex(0);
    if ((TempIn_1 >= -50) && (TempIn_1 <= 150)) { Temp_1 = TempIn_1; }
    if (TempIn_1 < -50)  { Temp_1 = -60; }
    if (TempIn_1 > 150)  { Temp_1 = 160; }
}

if (TempCheck == 1) {
    TempIn_2 = sensors.getTempFByIndex(1);
    if ((TempIn_2 >= -50) && (TempIn_2 <= 150)) { Temp_2 = TempIn_2; }
    if (TempIn_2 < -50)  { Temp_2 = -60; }
    if (TempIn_2 > 150)  { Temp_2 = 160; }
}

if (TempCheck == 2) {
    TempIn_3 = sensors.getTempFByIndex(2);
    if ((TempIn_3 >= -50) && (TempIn_3 <= 150)) { Temp_3 = TempIn_3; }
    if (TempIn_3 < -50)  { Temp_3 = -60; }
    if (TempIn_3 > 150)  { Temp_3 = 160; }
}/*
Serial.print("TempCheck > ");
Serial.print(TempCheck);
Serial.print("Temp > ");
Serial.print(Temp_1);
Serial.print(" ");
Serial.print(Temp_2);
Serial.print(" ");
Serial.println(Temp_3);


	if (TempCheck == 0) {
	  TempIn_1 = sensors.getTempFByIndex(0);
	  if ((TempIn_1 > -50) && (TempIn_1 < 150)) {
      Temp_1 = TempIn_1;
      TempError1 = 0;
     } else { 
     TempError1 = TempError1 + 1;
     } 	  
	  }
   
	if (TempCheck == 1) {
	  TempIn_2 = sensors.getTempFByIndex(1);
	    if ((TempIn_2 > -50) && (TempIn_2 < 150)) {
      Temp_2 = TempIn_2;
     TempError2 = 0;
     } else { 
      TempError2 = TempError2 + 1;
     }	  
	  }
   
	if (TempCheck == 2) {
	  TempIn_3 = sensors.getTempFByIndex(2);
	    if ((TempIn_3 > -50) && (TempIn_3 < 150)) {
      Temp_3 = TempIn_3;
      TempError3 = 0;
     } else { 
      TempError3 = TempError3 + 1;
     }
	  }
   
    // if a sensor is reporting an error for 30 consecutive seconds, then we flag it by setting the temp to -60

 if (TempError1 > 60) { 
  Temp_1 = -60;
  TempError1 > 100;
 }
 
  if (TempError2 > 60) { 
  Temp_2 = -60;
  TempError2 > 100;
 }
 
  if (TempError3 > 60) { 
  Temp_3 = -60;
  TempError3 > 100;
 }
*/
  sensors.requestTemperatures();
  TempCheck = TempCheck + 1;
  
  if (TempCheck > 2) {TempCheck = 0;}
	
}
